PLL

.protect
.lib 'cic018.l' TT
.unprotect
.temp 27
.option 
+ post $output vaveform 
+ captab $list node capacitance
+ accurate=1 runlvl=6 $simulator resolution
*+ ABSTOL=1e-7 RELTOL=1e-7 accurate=1 runlvl=6 $simulator resolution

.include "pd.spi" *.subckt pd vdd vss vin1 vin2 vout
.include "oscillator.spi" *.subckt osc vdd vss vctrl1 vctrl2 vout8 vout7
*.include "buf.spi" *.subckt buf vdd vss vin1 vin2 vout
.include "buf_n.spi" *.subckt bufn vdd vss vin1 vin2 vout

.param 
+ Wn_inv=1u Wp_inv=3u Ln_inv=0.18u Lp_inv=0.18u
+ R_lpf=7k C_lpf=10f *steady-state at the begin
+ Rvd_val=1k

*+ R_lpf=7k C_lpf=10p

***** Circuit *****

*** Phase detector ***
Xpd vdd vss vin vbuf pd_out pd 

*** inverter ***
Minvn1 nv1 pd_out vss vss N_18 w=Wn_inv l=Ln_inv m=1
M1nvp1 nv1 pd_out vdd vdd P_18 w=Wp_inv l=Lp_inv m=1
Minvn2 nv2    nv1 vss vss N_18 w=Wn_inv l=Ln_inv m=1
M1nvp2 nv2    nv1 vdd vdd P_18 w=Wp_inv l=Lp_inv m=1
Minvn3 nv3    nv2 vss vss N_18 w=Wn_inv l=Ln_inv m=1
M1nvp3 nv3    nv2 vdd vdd P_18 w=Wp_inv l=Lp_inv m=1
*Minvn4 nv4    nv3 vss vss N_18 w=Wn_inv l=Ln_inv m=1
*M1nvp4 nv4    nv3 vdd vdd P_18 w=Wp_inv l=Lp_inv m=1

*** voltage divider ***
R1 nv3 nvd 5*Rvd_val
R2 nvd vss 1*Rvd_val 

*** low-pass filter ***
Rlpf nvd vctrl1 R_lpf
Clpf vctrl1 vss C_lpf

*** oscillator ***
Xosc vdd vss vctrl1 vctrl2 vout1 vout2 osc

*** buf ***
Xbuf vdd vss vout2 vout1 vbuf bufn

***** Source *****
Vdd vdd 0 1.8
Vss vss 0 0

Vin vin vss sin(0.9 0.9 500Meg 1n)
Vctrl2 vctrl2 vss 0.4 *For 500MHz
*Vctrl2 vctrl2 vss 0.23 *For 600MHz
*Vctrl2 vctrl2 vss 0.51 *For 400MHz
*Vctrl2 vctrl2 vss 0.6 *For 300MHz *Fail

***** Simulation *****
.op

.tran 1n 500n
*.tran 1n 10u
.ic V(vctrl1)=0.4

.end
